This is an async implementation of the 
[babel routing protocol](https://www.rfc-editor.org/info/rfc8966) in Rust for 
my OpenBSD router. I want it to run everywhere I need a babel routing daemon, 
because the routing software I use doesn't support the babel protocol.

Note: despite the name, I am not affiliated with the OpenBSD project.

## TODO:
### 3.1
- [x] Message Transmission and Reception

### 3.2
- [ ] All data structures implemented 
- [x] Sequence Number Arithmetic
- [ ] Node Sequence Number
- [x] Interface Table
- [x] Neighbor Table 
- [ ] Source Table 
- [ ] Route Table 
- [ ] Table of Pending Seqno Requests

### 3.3
- [ ] Acknowledgments and Acknowledgment Requests

### 3.4
- [ ] Neighbour Acquisition
- [x] Reverse Reachability Detection
- [x] Bidirectional Reachability Detection
- [ ] Cost Computation

### 3.5
- [ ] Routing Table Maintenance
- [ ] The Feasibility Condition
- [ ] Metric Computation
- [ ] Route Acquisition
- [ ] Hold Time

### 3.6
- [ ] Route Selection

### 3.7
- [ ] Sending Updates
- [x] Periodic Updates
- [ ] Triggered Updates 
- [ ] Maintaining Feasibility Distances
- [ ] Split Horizon

### 3.8
- [ ] Explicit Requests
- [ ] Handling Requests
- [ ] Route Requests
- [ ] Seqno Requests
- [ ] Sending Requests
- [ ] Avoiding Starvation
- [ ] Dealing with Unfeasible Updates
- [ ] Preventing Routes from Expiring

### 4.1
- [x] Representation of Integers
- [x] Interval
- [x] Router-Id
- [x] Address
- [x] Prefixes

### 4.6
- [x] Pad1
- [x] PadN
- [ ] Acknowledgment Request
- [x] Acknowledgment 
- [x] Hello 
- [x] IHU
- [x] Router-Id
- [x] Next Hop
- [x] Update
- [ ] Route Request 
- [ ] Seqno Request 

### 4.7
- [x] Sub TLVs

